function [DH]=DH_MACH_end(x,nv,length_I,y,g_x,I_need,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s)

    f_xx=obj_hes(x);
    g_xx=aggM_jac_end(x,I_need,length_I,nv,g_x,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s);
    Hx = [f_xx+y*g_xx; y*g_x'];
    Hy = [g_x; g_a];
    DH = [Hx Hy];
return


    
function  g_xx=aggM_jac_end(x,I_need,length_I,nv,g_x,t_theta,g_i_x,term_x,term_exp,term_sum,alpha,grad_s,hess_s)

global   b 
            g_i_xx=con_hes(x,I_need,length_I); 
            term_3=(alpha +2*(t_theta/b)*grad_s+(t_theta/b)^2*hess_s).*term_exp(1:end-1)/term_sum; 
            term_t=repmat(term_3',nv,1);            
            g_xx = reshape(g_i_xx*term_x,nv,nv)+(g_i_x.*term_t*g_i_x'-g_x*g_x')/t_theta; 
return