function  [H,DH,num_c]=Hessian(x,y,t,g,max_g,length_I,g_need,I_need)

global ini_x ini_y ini_g  meth nv  dim_g num_smooth

    f_x=obj_grad(x); f_xx=obj_hes(x);
if meth==1
    I_need=(1:dim_g)';
    num_c=dim_g;
    num_smooth=num_smooth+num_c;    
    g_x=con_grad(x,I_need,dim_g); 
    H=[(1-t)*(f_x+g_x*y)+t*(x-ini_x); y.*g-t*ini_y.*ini_g];
    
    g_xx=con_hes(x,I_need,dim_g); 
    Hx=[(1-t)*(f_xx+reshape(g_xx*y,nv,nv))+t*speye(nv); spdiags(y,0,dim_g,dim_g)*g_x'];
    Hy=[(1-t)*g_x; spdiags(g,0,dim_g,dim_g)];
    Ht=[-(f_x+g_x*y)+(x-ini_x);-ini_y.*ini_g];    
    DH=[Hx Hy Ht];   
    return
elseif meth==2
    num_c=dim_g;
    num_smooth=num_smooth+num_c;
%     [g_a,g_x,g_t,g_xx,g_xt]=aggregate(x,t,g);
    [g_a,g_x,t_theta,g_i_x,lambda,term_exp,term_sum]=aggH_fun(x,t,g);
    H  = [(1-t)*(f_x+y*g_x)+t*(x-ini_x); y*g_a-t*ini_y*ini_g];  
    
    I_need=(1:dim_g)';length_I=dim_g;
    [g_t,g_xx,g_xt]=aggH_jac(x,t,g,I_need,length_I,g_a,g_x,t_theta,g_i_x,lambda,term_exp,term_sum);
    Hx = [(1-t)*(f_xx+y*g_xx)+t*eye(nv); y*g_x'];
    Hy = [(1-t)*g_x; g_a];
    Ht = [-(f_x+y*g_x)+(1-t)*y*g_xt+(x-ini_x);y*g_t-ini_y*ini_g];
    DH = [Hx Hy Ht]; 
    return
elseif meth==3
    if length_I>0
        num_c=length_I;
        num_smooth=num_smooth+num_c;
%         [g_a,g_x,g_t,g_xx,g_xt]=aggregate(x,t,g_need,I_need,length_I);
        [g_a,g_x,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s]=aggH_fun(x,t,g_need,I_need,length_I,max_g);
        H  = [(1-t)*(f_x+y*g_x)+t*(x-ini_x); y*g_a-t*ini_y*ini_g];
        [g_t,g_xx,g_xt]=aggH_jac(x,t,g_need,I_need,length_I,g_a,g_x,t_theta,g_i_x,lambda,term_exp,term_sum,alpha,grad_s,hess_s);
        Hx = [(1-t)*(f_xx+y*g_xx)+t*eye(nv); y*g_x'];
        Hy = [(1-t)*g_x; g_a];
        Ht = [-(f_x+y*g_x)+(1-t)*y*g_xt+(x-ini_x);y*g_t-ini_y*ini_g];
        DH = [Hx Hy Ht];
        return
    else
        num_c=0;
        x_ini_x_f_x=x-ini_x-f_x;
        H  = f_x+t*x_ini_x_f_x;
        Hx = (1-t)*f_xx+t*eye(nv);
        Ht = x_ini_x_f_x;
        DH = [Hx Ht];   
        return
    end
elseif meth==4
    num_c=length_I;
    num_smooth=num_smooth+num_c;
    num_smooth=num_smooth+length_I;
%     [g_a,g_x,g_t,g_xx,g_xt]=aggregate(x,t,g_need,I_need,length_I,max_g);
    [g_a,g_x,t_theta,g_i_x,lambda]=aggH_fun(x,t,g_need,I_need,length_I,max_g);
    H  = [(1-t)*(f_x+y*g_x)+t*(x-ini_x); y*g_a-t*ini_y*ini_g];
    [g_t,g_xx,g_xt]=aggH_jac(x,t,g_need,I_need,length_I,g_a,g_x,t_theta,g_i_x,lambda);
    Hx = [(1-t)*(f_xx+y*g_xx)+t*eye(nv); y*g_x'];
    Hy = [(1-t)*g_x; g_a];
    Ht = [-(f_x+y*g_x)+(1-t)*y*g_xt+(x-ini_x);y*g_t-ini_y*ini_g];
    DH = [Hx Hy Ht];
    return    
end
    

