function [grad,hess]=test_grad_hess(x,t,theta)
warning off;
global theta;
global t;

n=length(x);
%x=[1.08 1.01 1 1.01 1.01 1.20];
delta=1e-4;
grad=zeros(n,1);
f1=zeros(n,1);
f0=objfun(x,t,theta);
%f0=f0(100);
for i=1:n
    x0=x;
    x0(i)=x(i)+delta;
    f1(i)=objfun(x0,t,theta);
end
 grad=(f1-f0)/delta;
hess=zeros(n,n);
for i=1:n
    xi=x;
    xi(i)=xi(i)+delta;
    fi=objfun(xi,t,theta);
   % fi=fi(100);
    for j=1:n
        xj=x;
        xj(j)=xj(j)+delta;
        xij=xi;
        xij(j)=xi(j)+delta;
        fij=objfun(xij,t,theta);
      %  fij=fij(100);
        fj=objfun(xj,t,theta);
       % fj=fj(100);
        hess(i,j)=(fij-fi-fj+f0)/delta^2;
    end
end
hess