function  [x,x0,y,y0,t,t0,k,flag_cor,flag_pre]=Newton(first_x,first_y,first_t,d,m_max,epison,x,y,t) 

% Newton correct to solve H=0 and & d'[z-first_z; t-first_t]=0

global  nv   meth dim_g ini_x ini_y ini_g num_smooth 

k=0;flag_pre=1;
% initial point
x1=first_x; y1=first_y;t1=first_t;x0=[];y0=[];t0=0;g=con_fun(x1);
% % % % % % % 
if meth==1   
    I_need=(1:dim_g)';length_I=dim_g;
    if max(g)>1e-6
        flag_cor=0;
        return
    end        
    [H,f_x,g_x]=H_CHIP(x1,y1,t1,g,dim_g,ini_x,ini_y,ini_g,I_need);  
    DH=DH_CHIP(f_x,x1,y1,t1,g,g_x,ini_x,ini_y,ini_g,nv,dim_g,I_need);
    num_smooth=num_smooth+dim_g;     
elseif meth==2
    I_need=(1:dim_g)';length_I=dim_g;
    max_g=max(g);
    [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_ACH(x1,y1,t1,ini_x,ini_y,ini_g,g,max_g,dim_g,I_need); 
    
    if g_a>1e-6
        flag_cor=0;
        return
    end
    DH=DH_ACH(f_x,x1,y1,t1,ini_x,ini_y,ini_g,g,g_a,g_x,t_theta,g_i_x,lambda,I_need,nv,dim_g);
    num_smooth=num_smooth+dim_g; 
elseif meth==3 
    global  b g0
    I_need=find(g>-b);
    length_I=length(I_need);     
    if length_I>0
        g_need=g(I_need);
        max_g=max(g_need);
        [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s]=...
              H_MACH(x1,ini_x,t1,length_I,ini_y,ini_g,y1,max_g,g_need,I_need);
        if g_a>1e-6
            flag_cor=0;
            return
        end 
        [DH]=DH_MACH(f_x,x1,ini_x,t1,nv,length_I,y1,ini_y,ini_g,g_x,g_need,I_need,...
              g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s);
         num_smooth=num_smooth+length_I;   
    else
        g_a=ini_g;
        f_x=obj_grad(x1);
        x1_ini_x_f_x=x1-ini_x-f_x;
        H  = f_x+t1*x1_ini_x_f_x;
        f_xx=obj_hes(x1);
        DH = [(1-t1)*f_xx+t1*eye(nv) x1_ini_x_f_x];
    end
    
elseif meth==4
    global theta bound_alpha bound_g bound_grad_g bound_hess_g epsilon_grad epsilon_hess;
    t_theta=t*theta;
    max_g=max(g);
    a_g=bound_alpha*((1-t)*2*bound_grad_g+t_theta);
    b_g=(1-t)*bound_alpha*(2*bound_hess_g+6/t_theta*bound_grad_g*(bound_grad_g+bound_g/t))+...
        2*(2*bound_alpha+1-t)*bound_grad_g+t_theta+bound_alpha/t*(t_theta+2*bound_g);       
    term=max(2*a_g/epsilon_grad,2*b_g/epsilon_hess);
    M_g=t_theta*log((dim_g-1)*term);
    I_need=find(g>=max_g-M_g);
    length_I=length(I_need);
    g_need=g(I_need); 
    [H,f_x,g_x,g_a,t_theta,g_i_x,lambda]=H_TACH(x1,y1,t1,max_g,length_I,g_need,I_need,ini_x,ini_y,ini_g);
   
    if g_a>1e-6
        flag_cor=0;
        return
    end
    [DH]=DH_TACH(f_x,x1,y1,t1,length_I,g_x,g_need,I_need,g_a,t_theta,g_i_x,lambda,ini_x,ini_y,ini_g,nv);
    num_smooth=num_smooth+length_I; 
elseif meth==5
    global  c g0
    I_need=find(g>-c); 
    length_I=length(I_need);
    if length_I>0
        g_need=g(I_need);
        [H,f_x,g_x,gg_max,g_i_x,gg_i_x,g_a,gg_need,t_theta,lambda,term_sqrt,term_exp,term_sum,term_gg_x,alpha,grad_s,hess_s]=...
                  H_SACH(x1,ini_x,t1,length_I,y1,ini_y,ini_g,g_need,dim_g,I_need);              
        if g_a>1e-6
            flag_cor=0;
            return
        end
        [DH]=DH_SACH(f_x,x1,ini_x,t1,nv,length_I,y1,ini_y,ini_g,gg_need,gg_i_x,gg_max,g_a,g_x,t_theta,g_i_x,...
            lambda,term_sqrt,term_sum,term_gg_x,alpha,grad_s,hess_s,I_need,dim_g); 
        num_smooth=num_smooth+length_I; 
    else
        g_a=ini_g;
        f_x=obj_grad(x1);
        x1_ini_x_f_x=x1-ini_x-f_x;
        H  = f_x+t1*x1_ini_x_f_x; 
        f_xx=obj_hes(x1);
        DH = [(1-t1)*f_xx+t1*eye(nv) x1_ini_x_f_x]; 
    end  
     elseif meth==6
         global theta;
        % normx=norm(x1-x)*max(-g);
       % if normx<1e-7;
        %g_need=g(I_need);
       % t_theta=t1*theta;
       % else
       % [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t1,theta);
       % end
      [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t1,theta);
%L=length_I
%T=I_need'
    [H,f_x,g_x,g_i_x,g_a,lambda_x]=H_SCH(x1,y1,t1,ini_x,ini_y,ini_g,g,length_I,I_need,g_need,t_theta,h); 
  
    if -g_a>1e-6
        flag_cor=0;
        return
    end
    
    DH=DH_SCH(f_x,x1,y1,t1,ini_x,ini_y,ini_g,g,g_a,g_x,t_theta,g_need,g_i_x,lambda_x,I_need,nv,length_I,h);
    
    num_smooth=num_smooth+length_I; 
end

while 1

    if length_I>0
        h_h=-[DH;d']\[H;0];
    else
        h_h=-[DH;d(1:nv)' d(end)]\[H(1:nv);0];
    end
    k=k+1; 
    nh=norm(h_h);
    t2=t1+h_h(end);
    if t2>1
        flag_cor=0; 
        return  
    end   
    if t2<0
        if nh>100
            flag_cor=0;
            return
        else 
            flag_pre=0;flag_cor=1;
            step_t=-t1/h_h(end);
            if length_I>0
                y0=y1+step_t*h_h(nv+1:end-1);
            else
                y0=zeros(dim_g,1);
            end
            x0=x1+step_t*h_h(1:nv);
            return
        end
    else
        if length_I>0
            y2=y1+h_h(nv+1:end-1);
            if   y2<0 
                flag_cor=0;
                return
            end
        else
            if meth==3
                y2=t2*ini_y*ini_g/g0;
            elseif meth==5
                y2=t2*ini_y*ini_g/g0;
            end
        end
         x2=x1+h_h(1:nv);
    end   
    g=con_fun(x2);
    if meth==1
        [H,f_x,g_x]=H_CHIP(x2,y2,t2,g,dim_g,ini_x,ini_y,ini_g,I_need);  
        g_a=max(g);
    elseif  meth==2 
        max_g=max(g);
        [H,f_x,g_x,g_i_x,g_a,t_theta,lambda]=H_ACH(x2,y2,t2,ini_x,ini_y,ini_g,g,max_g,dim_g,I_need);
        
    elseif meth==3 
        I_need=find(g>-b); 
        length_I=length(I_need);          
        if length_I>0
             g_need=g(I_need);
             max_g=max(g_need);
             [H,f_x,g_x,g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s]=...
                          H_MACH(x2,ini_x,t2,length_I,ini_y,ini_g,y2,max_g,g_need,I_need);
        else
            f_x=obj_grad(x2);
            x2_ini_x_f_x=x2-ini_x-f_x;
            H  = f_x+t2*x2_ini_x_f_x; 
        end
        
    elseif meth==4
         t_theta=t*theta;
         max_g=max(g);
         a_g=bound_alpha*((1-t)*2*bound_grad_g+t_theta);
         b_g=(1-t)*bound_alpha*(2*bound_hess_g+6/t_theta*bound_grad_g*(bound_grad_g+bound_g/t))+...
             2*(2*bound_alpha+1-t)*bound_grad_g+t_theta+bound_alpha/t*(t_theta+2*bound_g);       
         term=max(2*a_g/epsilon_grad,2*b_g/epsilon_hess);
         M_g=t_theta*log((dim_g-1)*term);
         I_need=find(g>=max_g-M_g);
         %I_need'
         length_I=length(I_need);                              
         g_need=g(I_need); 
         [H,f_x,g_x,g_a,t_theta,g_i_x,lambda]=H_TACH(x2,y2,t2,max_g,length_I,g_need,I_need,ini_x,ini_y,ini_g);
    elseif meth==5
         I_need=find(g>-c); 
         length_I=length(I_need); 
         if length_I>0
             g_need=g(I_need);
             [H,f_x,g_x,gg_max,g_i_x,gg_i_x,g_a,gg_need,t_theta,lambda,term_sqrt,term_exp,term_sum,term_gg_x,alpha,grad_s,hess_s]=...
                 H_SACH(x2,ini_x,t2,length_I,y2,ini_y,ini_g,g_need,dim_g,I_need); 
         else
             f_x=obj_grad(x2);
             x2_ini_x_f_x=x2-ini_x-f_x;
             H  = f_x+t2*x2_ini_x_f_x; 
         end
          elseif  meth==6 
            global theta
            flag_cell=0;
              
              
          for i=1:(length_I-1);
              if g(I_need(i))>=g(I_need(i+1));
                  flag_cell=1;
              else 
                 break;
              end
          end
          %flag_cell
          if flag_cell;
              g_need=-g(I_need);
             t_theta=t2*theta;
         else
        [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t2,theta);
         end
        %  normx1=norm(x1-x2);
        %if normx1<1e-16;
           % T1=I_need'
        % g_need=g(I_need);
         %t_theta=t2*theta;
        % else
        %[g_need,length_I,t_theta,I_need,h]=cell_find(-g,t2,theta);
        % end
        % [g_need,length_I,t_theta,I_need,h]=cell_find(-g,t2,theta);
        %length_I
        %L1=I_need'
         
        [H,f_x,g_x,g_i_x,g_a,lambda_x]=H_SCH(x2,y2,t2,ini_x,ini_y,ini_g,g,length_I,I_need,g_need,t_theta,h);
      g_a=-g_a;
    end
   
    nf=norm(H,inf);
    if  nh<epison&nf<epison&g_a<=0
        flag_cor=2;
        x=x2;y=y2;t=t2;  
        return
    else
        x1=x2;y1=y2; t1=t2;
    end 
   
    if k==m_max
        flag_cor=1;
        return
    end
    if meth==1
        DH=DH_CHIP(f_x,x2,y2,t2,g,g_x,ini_x,ini_y,ini_g,nv,dim_g,I_need);
        num_smooth=num_smooth+dim_g;     
    elseif  meth==2    
        DH=DH_ACH(f_x,x2,y2,t2,ini_x,ini_y,ini_g,g,g_a,g_x,t_theta,g_i_x,lambda,I_need,nv,dim_g);
        num_smooth=num_smooth+dim_g;     
    elseif meth==3  
        if length_I>0
            [DH]=DH_MACH(f_x,x2,ini_x,t2,nv,length_I,y2,ini_y,ini_g,g_x,g_need,I_need,...
                g_a,t_theta,g_i_x,lambda,term_exp,term_sum,term_1,alpha,grad_s,hess_s);
            num_smooth=num_smooth+length_I; 
        else
            f_xx=obj_hes(x2);
            DH = [(1-t2)*f_xx+t2*eye(nv) x2_ini_x_f_x]; 
        end               
    elseif meth==4
         [DH]=DH_TACH(f_x,x2,y2,t2,length_I,g_x,g_need,I_need,g_a,t_theta,g_i_x,lambda,ini_x,ini_y,ini_g,nv);
         num_smooth=num_smooth+length_I;          
    elseif meth==5
         if length_I>0
             [DH]=DH_SACH(f_x,x2,ini_x,t2,nv,length_I,y2,ini_y,ini_g,gg_need,gg_i_x,gg_max,g_a,g_x,t_theta,g_i_x,...
                lambda,term_sqrt,term_sum,term_gg_x,alpha,grad_s,hess_s,I_need,dim_g);
             num_smooth=num_smooth+length_I; 
         else
             f_xx=obj_hes(x2);
             DH = [(1-t2)*f_xx+t2*eye(nv) x2_ini_x_f_x]; 
         end   
          elseif  meth==6    
          g_a=- g_a;   
          
        DH=DH_SCH(f_x,x2,y2,t2,ini_x,ini_y,ini_g,g,g_a,g_x,t_theta,g_need,g_i_x,lambda_x,I_need,nv,length_I,h);
         
        num_smooth=num_smooth+length_I; 
    end      
end